Player = Object:extend()

function Player:new(x, y)
    self.x = x
    self.y = y
    self.width = 32
    self.height = 32
    self.speed = 5
    self.vx = 0
    self.vy = 400
    self.isJumping = false
    self.isGrounded = false
    self.canDoubleJump = false
    self.doubleJumpReload = 10
    self.startCount = false
    self.isPlayer = true
    self.facing = ""
    self.stompReload = 5
    self.canStomp = false
end

function Player:update(dt)
  
    
    if love.keyboard.isDown("a") then
        self.vx = -150
        self.facing = "left"
        
    end
    if love.keyboard.isDown("d") then
        self.vx = 150
        self.facing = "right"
        
    end
    
    self.stompReload = self.stompReload - 1 
    
    if love.keyboard.isDown("a") and self.isGrounded and self.stompReload < 0 then
        table.insert(listOfEffect, Effect(self.x, self.y + 24, math.random(5, 8), math.random(5, 8), -1, "Brownout", "dirt", 0.01))
        table.insert(listOfEffect, Effect(self.x + 32, self.y + 24, math.random(5, 8), math.random(5, 8), 1, "Brownout", "dirt", 0.01))
        self.stompReload = 5
    end
    
    if love.keyboard.isDown("d") and self.isGrounded  and self.stompReload < 0 then
        table.insert(listOfEffect, Effect(self.x, self.y + 24, math.random(5, 8), math.random(5, 8), -1, "Brownout", "dirt", 0.01))
        table.insert(listOfEffect, Effect(self.x + 32, self.y + 24, math.random(5, 8), math.random(5, 8), 1, "Brownout", "dirt", 0.01))
        self.stompReload = 5
    end
    
    if self.startCount then
        self.doubleJumpReload = self.doubleJumpReload - 1
    end
    if self.doubleJumpReload <= 0 then
        self.canDoubleJump = true
    end
    --[[if love.keypressed("w", false) and self.isGrounded then
        self.vy = -400
        self.isJumping = true
        self.isGrounded = false
        self.doubleJumpReload = 10
        self.startCount = true
    end
    
    if love.keyboard.isDown("w") and self.canDoubleJump then
        self.vy = -400
        self.isJumping = true
        self.isGrounded = false
        self.canDoubleJump = false
        self.doubleJumpReload = 10
        self.startCount = false
    end]]--
    
    if self.vy < 400 then
        self.vy = self.vy + 20
    end
    
    local function playerFilter(item, other)
        if other.isWater then return 'cross'
        elseif other.isBlock then return 'slide'
        end
      
    end
    
    local goalX, goalY = self.x + self.vx * dt, self.y + self.vy * dt
    local actualX, actualY, cols, len = world:move(self, goalX, goalY, playerFilter)
    self.x, self.y = actualX, actualY
    -- deal with the collisions 
    for i=1,len do
        local other = cols[i].other
        if other.isBlock and self.y < other.y then
            self.isGrounded = true
        end
    end
    
    if  self.isGrounded and self.canStomp then
        table.insert(listOfEffect, Effect(self.x, self.y + 24, math.random(5, 8), math.random(5, 8), -1, "Brownout", "dirt", 0.01))
        table.insert(listOfEffect, Effect(self.x + 32, self.y + 24, math.random(5, 8), math.random(5, 8), 1, "Brownout", "dirt", 0.01))
        table.insert(listOfEffect, Effect(self.x, self.y + 24, math.random(5, 8), math.random(5, 8), -1, "Brownout", "dirt", 0.01))
        table.insert(listOfEffect, Effect(self.x + 32, self.y + 24, math.random(5, 8), math.random(5, 8), 1, "Brownout", "dirt", 0.01))
        table.insert(listOfEffect, Effect(self.x, self.y + 24, math.random(5, 8), math.random(5, 8), -1, "Brownout", "dirt", 0.01))
        table.insert(listOfEffect, Effect(self.x + 32, self.y + 24, math.random(5, 8), math.random(5, 8), 1, "Brownout", "dirt", 0.01))
        table.insert(listOfEffect, Effect(self.x, self.y + 24, math.random(5, 8), math.random(5, 8), -1, "Brownout", "dirt", 0.01))
        table.insert(listOfEffect, Effect(self.x + 32, self.y + 24, math.random(5, 8), math.random(5, 8), 1, "Brownout", "dirt", 0.01))
        self.canStomp = false
    end
    
    self.vx = 0 
end


function Player:draw()
    love.graphics.setColor(255, 255, 255)
    love.graphics.rectangle("fill", self.x, self.y , self.width, self.height)
end